----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 01/11/2024 02:39:47 PM
-- Design Name: 
-- Module Name: TOP - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity TOP is
    Port ( btnR : in STD_LOGIC; -- Zmiana trybu wiecenia
           btnC : in STD_LOGIC; -- wcz/wycz
           btnL : in STD_LOGIC; -- Zmiana prdkoci wiecenia 
           clk : in STD_LOGIC;
           led : out STD_LOGIC_VECTOR (7 downto 0));
end TOP;

architecture Behavioral of TOP is

signal COUT : STD_LOGIC := '0';
signal BTNR_O : STD_LOGIC := '0';
signal BTNC_O : STD_LOGIC := '0';
signal BTNL_O : STD_LOGIC := '0';
signal LED_1 : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
signal LED_2 : STD_LOGIC_VECTOR (7 downto 0) := "00000000";


begin

Debouncer: entity work.Debouncer PORT MAP (
        CLOCK_IN => clk,
        BIN => btnR,
        BOUT => BTNR_O
        );
Debouncer_1: entity work.Debouncer PORT MAP (
        CLOCK_IN => clk,
        BIN => btnC,
        BOUT => BTNC_O
        );  
Debouncer_2: entity work.Debouncer PORT MAP (
        CLOCK_IN => clk,
        BIN => btnL,
        BOUT => BTNL_O
        );      
         
Prescaler: entity work.Prescaler GENERIC MAP(prescalar => 5)
	PORT MAP (
	      INPUT => BTNL_O, 
          CLOCK_IN => clk,
          CLOCK_OUT => COUT
        );

Counter: entity work.Counter PORT MAP (
        INPUT_C => BTNC_O, --Tutaj podajemy wyjcie z przycisku debouncera
        INPUT_R => BTNR_O, --Tutaj podajemy wyjcie z przycisku debouncera
        INPUT_1 => LED_1, --wyjcia modu nr1 do tego wejcia
        INPUT_2 => LED_2, --wyjcia modu nr2 do tego wejcia
        OUTPUT => led, --wyjcie podaczone do ledow
        CLOCK_IN => clk
        );

Mode7: entity work.Mode7 PORT MAP (
          RESET => BTNR_O,
          CLOCK_IN => clk,
          TICK => COUT,
          ledy_1 => LED_1
        );

Mode2: entity work.Mode2 PORT MAP (
          RESET => BTNR_O,
          CLOCK_IN => clk,
          TICK => COUT,
          ledy_2 => LED_2
        );
end Behavioral;
