----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 13.01.2024 14:44:23
-- Design Name: 
-- Module Name: Counter - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Counter is
 Port ( 
        INPUT_C : in  STD_LOGIC; --Tutaj podajemy wyjcie z przycisku odpowiadajcy za wczenie i wyczenie
        INPUT_R : in  STD_LOGIC; --Tutaj podajemy wyjcie z przycisku odpowiadajcy za zmian trybu wiecenia
        INPUT_1 : in  STD_LOGIC_VECTOR (7 downto 0); --wyjcia modu nr1 do tego wejcia
        INPUT_2 : in  STD_LOGIC_VECTOR (7 downto 0); --wyjcia modu nr2 do tego wejcia
        CLOCK_IN : in  STD_LOGIC;
        OUTPUT : out  STD_LOGIC_VECTOR (7 downto 0) --wyjcie podaczone do ledow
        );
end Counter;

architecture Behavioral of Counter is

signal count_r : integer := 0;
signal count_c : integer := 0;
signal output_multi : STD_LOGIC_VECTOR (7 downto 0):= "00000000"; --powiedzmy e output multiplexera
signal led_output : STD_LOGIC_VECTOR (7 downto 0):= "00000000"; --powiedzmy e output multiplexera
signal led_off : STD_LOGIC_VECTOR (7 downto 0):= "00000000"; -- ten wektor nie bdzie zmieniany i ma suy jako wyczenie ledw

begin

OUTPUT <= led_output;

Counter : process (CLOCK_IN)
begin
    if(rising_edge(CLOCK_IN)) then
        if(INPUT_R = '1') then
            if(count_r = 0) then
                count_r <= 1;
                output_multi <= INPUT_1;
            else
                count_r <= 0;
                output_multi <= INPUT_2;
            end if;
        end if;
        if(INPUT_C = '1') then
            if(count_c = 0) then
                count_c <= 1;
                led_output <= output_multi;
            else
                count_c <= 0;
                led_output <= led_off;
            end if;
        end if;
    end if;
end process;
end Behavioral;
